w******************************************************************
**								**
**		.xvd easy Frame Viewer 2	ver0.6		**
**								**
**						by ӂȂۂ	**
**								**
**					since May 20 1997	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	CONST.H

	.cpu	68000


	.offset	0

SSP_SAVE::		.ds.l	1

MAGIC_HEADER::		.ds.b	4
DATA_AUTHOR::		.ds.b	32
SUB_TITLE::		.ds.b	32
TITLE::			.ds.b	64
END_MARKER::		.ds.b	4
FORMAT_REVISION::	.ds.b	4
DATA_OFFSET::		.ds.b	4
HEADER_OFFSET::		.ds.b	4
FRAME_NUMBER::		.ds.b	4
X_LENGTH::		.ds.b	4
Y_LENGTH::		.ds.b	4
ASPECT_RATIO::		.ds.b	4
IMAGE_TYPE::		.ds.b	4
BASE_TIME_UNIT::	.ds.b	4
FRAME_RATE::		.ds.b	4
PCM_TYPE::		.ds.b	4
PCM_CHANNEL::		.ds.b	4
PCM_FREQENCY::		.ds.b	4
PCM_BLOCK_SIZE::	.ds.b	4

ON_GET_NUMBER::		.ds.l	1			*-f temp
ON_X_NUMBER::		.ds.l	1			*-a X
ON_Y_NUMBER::		.ds.l	1			*-a  ,Y
ONE_FRAME_ONLY_FLAG::	.ds.w	1			*-a only
POSTER_FLAG::		.ds.w	1			*-f nothing
GET_START_FRAME_NUMBER::.ds.l	1			*-sn
GET_END_FRAME_NUMBER::	.ds.l	1			*-en

IMAGE_SIZE::		.ds.l	1			*1 frame size
ON_FRAME_NUMBER::	.ds.b	8			*-f
ON_IMAGE_NUMBER::	.ds.w	1
X_ON_POINT::		.ds.l	1			*address
Y_ON_POINT::		.ds.l	1			*address
X_LOOP::		.ds.w	1			*How much X
Y_LOOP::		.ds.w	1			*         Y
MEMPTR::		.ds.l	1			*_malloc
CULC_X_LENGTH::		.ds.l	1			*+GV-RAM address
CULC_Y_LENGTH::		.ds.l	1			*+GV-RAM address
NUMBER_TEMP::		.ds.b	4			*-a temp
FILE_NAME::		.ds.b	256

WORK_SIZE::

	.text
	.even

	lea.l	MYSP(pc),sp			*X^bN|Cgw̃AhX
	movea.l	sp,A1
	lea.l	(16,a0),a0
	suba.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	_SETBLOCK			*
	addq.l  #8,sp

	lea.l	WORK(pc),a6

	moveq.l	#0,d0
	move.l	d0,ON_X_NUMBER(a6)
	move.l	d0,ON_Y_NUMBER(a6)
	move.l	d0,ON_GET_NUMBER(a6)
	move.l	d0,ON_X_NUMBER(a6)
	move.l	d0,ON_Y_NUMBER(a6)
	move.w	d0,ONE_FRAME_ONLY_FLAG(a6)
	move.w	d0,POSTER_FLAG(a6)
	move.l	d0,GET_START_FRAME_NUMBER(a6)
	move.l	d0,GET_END_FRAME_NUMBER(a6)

**********************************************************
**		Comand Line Option Check		**
**********************************************************
C_CHECK::
	addq.l	#1,a2
	bsr	SKIPSP				*Xy[XXLbv
	tst.b	(a2)				*邩H
	beq	USAGE				*Ȃ USAGE

	cmpi.b	#'-',(a2)
	beq	OP_CHECK
	cmpi.b	#'/',(a2)
	beq	OP_CHECK
	bra	GETARG				*t@C

OP_CHECK::
	addq.l	#1,a2				*"/""-"̕a2i߂Ă
	move.b	(a2)+,d0			*ꕶo
	bsr	TOUPPER				*啶ɕϊĂ
	cmpi.b	#"F",d0
	beq	ON_FRAME_NUMBER_GET
	cmpi.b	#"A",d0
	beq	ABSOLUTE_NUMBER_GET
	cmpi.b	#"V",d0
	beq	VIEW_MODE_ON
	cmpi.b	#"S",d0
	beq	START_FRAME_NUMBER_GET
	cmpi.b	#"E",d0
	beq	END_FRAME_NUMBER_GET
	bra	C_CHECK

VIEW_MODE_ON::
	move.w	#$000F,POSTER_FLAG(a6)
	bra	C_CHECK

ON_FRAME_NUMBER_GET::
	move.w	#1,POSTER_FLAG(a6)
	lea.l	ON_FRAME_NUMBER(a6),a0
	moveq.l	#0,d7

GET_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_NUMBER0_1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GET_NUMBER0_1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_NUMBER0

GET_NUMBER0_1::
	lea.l	ON_FRAME_NUMBER(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#$0000_FFFF,d2
	bgt	OVER_FLOW_FRAME
	move.l	d2,ON_GET_NUMBER(a6)
	bra	C_CHECK

ABSOLUTE_NUMBER_GET::
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_X_NUMBER0::
	cmpi.b	#',',(a2)
	beq	GET_X_NUMBER1
	cmpi.b	#SPACE,(a2)
	beq	ONE_FRAME_ONLY			* -a ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_X_NUMBER0

GET_X_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#511,d2
	bgt	OVER_X_NUMBER
	move.l	d2,ON_X_NUMBER(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	addq.l	#1,a2

GET_Y_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_Y_NUMBER1
	cmpi.b	#TAB,(a2)
	beq	GET_Y_NUMBER1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_Y_NUMBER0

GET_Y_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#511,d2
	bgt	OVER_Y_NUMBER
	move.l	d2,ON_Y_NUMBER(a6)
	bra	C_CHECK

ONE_FRAME_ONLY::
	tst.l	d7
	bne	IN_NUMBER_ERR
	move.w	#1,ONE_FRAME_ONLY_FLAG(a6)
	subq.l	#1,a2
	bra	C_CHECK

START_FRAME_NUMBER_GET::
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_START_FRAME_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_START_FRAME_NUMBER1		*-s ̎
	cmpi.b	#TAB,(a2)
	beq	GET_START_FRAME_NUMBER1		*-s ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_START_FRAME_NUMBER0

GET_START_FRAME_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
		cmpi.l	#$0000_FFFF,d2
		bgt	OVER_FLOW_FRAME
	move.l	d2,GET_START_FRAME_NUMBER(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	bra	C_CHECK

END_FRAME_NUMBER_GET::
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_END_FRAME_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_END_FRAME_NUMBER1		*-e ̎
	cmpi.b	#TAB,(a2)
	beq	GET_END_FRAME_NUMBER1		*-e ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_END_FRAME_NUMBER0

GET_END_FRAME_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
		cmpi.l	#$0000_FFFF,d2
		bgt	OVER_FLOW_FRAME
	move.l	d2,GET_END_FRAME_NUMBER(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	bra	C_CHECK

GETARG::
	lea.l	FILE_NAME(a6),a0

GETARG0::
	tst.b	(a2)				*̏I[R[hH
	beq	GETARG1

	cmpi.b	#SPACE,(a2)
	beq	GETARG1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GETARG1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ

	bra	GETARG0

GETARG1::
	clr.b	(a0)				*I[R[h

**********************************************************
**		READ .xvdFILE's HEAD 			**
**********************************************************
READ_FILE::
	move.w	#0,-(sp)			*READ only
	pea.l	FILE_NAME(a6)			*t@C
	DOS	_OPEN				*open
	addq.l	#6,sp

		tst.l	d0
		bmi	OPEN_ERROR

	move.w	d0,a5				*t@Cnha5֕ۑ

	move.l	#192,-(sp)			*Poster_Data܂ł̃wb_ől
	pea.l	MAGIC_HEADER(a6)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR
**********************************************************
**			XVD Check			**
**********************************************************
	cmpi.l	#'XVDF',MAGIC_HEADER(a6)
	bne	NOT_XVDDATA

	move.l	FRAME_NUMBER(a6),d0
	subq.l	#1,d0
	cmp.l	ON_GET_NUMBER(a6),d0
	blt	NUMBER_OVER

	cmpi.l	#$0002_0000,FORMAT_REVISION(a6)
	bne	NOT_REV200

	tst.l	IMAGE_TYPE(a6)
	bne	NOT_IMAGE_TYPE0

	move.l	ON_X_NUMBER(a6),d0
	move.l	X_LENGTH(a6),d1
	add.l	d0,d1
	cmpi.l	#512,d1
	bgt	OVER_X_NUMBER

	move.l	ON_Y_NUMBER(a6),d0
	move.l	Y_LENGTH(a6),d1
	add.l	d0,d1
	cmpi.l	#512,d1
	bgt	OVER_Y_NUMBER

	move.l	X_LENGTH(a6),d0
	move.l	d0,d2
	move.l	Y_LENGTH(a6),d1

	mulu.w	d1,d0
	add.l	d0,d0				*d1:Image_Size

	move.l	d0,IMAGE_SIZE(a6)

	subq.l	#1,d1

	move.l	d2,d3
	lsr.l	#1,d2				*d2/16
	subq.l	#1,d2

	move.l	d2,CULC_X_LENGTH(a6)

	move.l	#512,d4
	sub.l	d3,d4
	add.l	d4,d4
	move.l	d4,CULC_Y_LENGTH(a6)

	tst.w	POSTER_FLAG(a6)		*|X^[p
	beq	POSTER_ON		*|X^[{

**********************************************************
**			To GV-RAM			**
**********************************************************
ONLY_FRAME_CHECK::
	tst.l	ON_Y_NUMBER(a6)
	bne	FRAME_x1
	tst.l	ON_X_NUMBER(a6)
	bne	FRAME_x1			*Wŵ鎞

	tst.w	ONE_FRAME_ONLY_FLAG(a6)
	bne	FRAME_x1			* 1 frame Only
	bra	HOW_MANY_IMAGE

FRAME_x1::
	moveq.l	#1,d7				*\
	move.w	#1,ONE_FRAME_ONLY_FLAG(a6)
	bra	ON_FRAME_CHECK


HOW_MANY_IMAGE::				*\`FbN
	move.l	X_LENGTH(a6),d0
	move.l	d0,d1
	moveq.l	#0,d7
@@:
		add.w	d1,d0
		addq.l	#1,d7
		cmpi.w	#512,d0
		ble	@b

	move.w	d7,X_LOOP(a6)			*w։\ł邩

	move.l	Y_LENGTH(a6),d0
	move.l	d0,d1
	moveq.l	#0,d6
@@:
		add.w	d1,d0
		addq.l	#1,d6
		cmpi.w	#512,d0
		ble	@b

	move.w	d6,Y_LOOP(a6)			*x։\ł邩

	mulu.w	d6,d7
						*d7ɕ\\t[

	cmpi.w	#$000F,POSTER_FLAG(a6)
	beq	VIEW_MODE

ON_FRAME_CHECK::
	move.l	FRAME_NUMBER(a6),d0		*d0:t[
	move.l	d0,d5				*Ƃ̃`FbNp
	move.l	ON_GET_NUMBER(a6),d6		*d6:\Jnt[

	sub.l	d6,d0				*d0:c\t[
	cmp.l	d0,d7				*d7:\\t[
	ble	FL_CHK

	move.l	d0,d7				*d7:ŏI\
FL_CHK::
	move.w	d7,ON_IMAGE_NUMBER(a6)		*ŏI\
	move.l	IMAGE_SIZE(a6),d2
	move.l	PCM_BLOCK_SIZE(a6),d3
	moveq.l	#0,d1

@@:
	add.l	d2,d1				*d0:ړI̊G̃TCY
	dbra	d7,@B
						*d1:IMAGE

	move.l	d1,-(sp)			*image
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,MEMPTR(a6)
		bmi	MALLOC_ERROR

	moveq.l	#0,d1

	tst.l	d6
	beq	1F

	subq.l	#1,d6
@@:
	add.l	d3,d1
	add.l	d2,d1
	dbra	d6,@B
						*d1:΂
1:
	add.l	DATA_OFFSET(a6),d1		*0frame ܂ł offset

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d1,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	MEMPTR(a6),a2

	move.l	d2,-(sp)	*TCY
	move.l	a2,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	ON_IMAGE_NUMBER(a6),d7

	subq.l	#1,d7				*Pǂ񂾂
	tst.w	d7				*P̏ꍇ
	beq	COMPLETE

	subq.l	#1,d7				*dbrap

READ_LOOP::
	add.l	d2,a2

	move.w	#1,-(sp)			*݈ʒüړ
	move.l	d3,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d2,-(sp)	*TCY
	move.l	a2,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	dbra	d7,READ_LOOP

COMPLETE::
	move.w	a5,-(sp)
	DOS	_CLOSE				*$FF3E
	addq.l	#2,sp

		clr.l	-(sp)
		DOS	_SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE(a6)		* sspҔ
		addq.l	#4,sp

	tst.l	ASPECT_RATIO(a6)
	beq	SQUARE

X68K_ORIGINAL::
	move.w	#$C,d1
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON
	bra	@F

SQUARE::
	move.w	#$000C,d1			*ʃ[hw (C)MZL
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON
	move.w	#$0110,d1
	IOCS	_CRTMOD
	move.w	#$0316,$00e8_0028
	move.w	#$0003,$00e8_2400
	move.w	#$002f,$00e8_2600

@@:
	move.l	MEMPTR(a6),a0

	lea.l	$00c0_0000,a1
	move.l	a1,X_ON_POINT(a6)
	move.l	a1,Y_ON_POINT(a6)

	tst.w	ONE_FRAME_ONLY_FLAG(a6)
	bne	CULCULATION

	moveq.l	#0,d0
	moveq.l	#0,d1				*

	move.w	X_LOOP(a6),d0
	subq.l	#1,d0

	move.l	d0,d2				*d2:Y_loop-1
	move.w	Y_LOOP(a6),d1
	subq.l	#1,d1

	sub.w	#1,ON_IMAGE_NUMBER(a6)
LOOP::
	tst.w	ON_IMAGE_NUMBER(a6)
	blt	TO_GRAM_END

	bsr	TO_GRAM			*d0,d1,d2gps
	sub.w	#1,ON_IMAGE_NUMBER(a6)

	move.l	X_LENGTH(a6),d3
	add.l	d3,d3			*X_length x2
	add.l	d3,X_ON_POINT(a6)

	move.l	X_ON_POINT(a6),a1
	dbra	d0,LOOP

	moveq.l	#0,d3
	move.l	Y_LENGTH(a6),d3
	lsl.l	#8,d3
	lsl.l	#2,d3				*x1024
	add.l	d3,Y_ON_POINT(a6)
	move.l	Y_ON_POINT(a6),a1
	move.l	a1,X_ON_POINT(a6)
	move.l	d2,d0
	dbra	d1,LOOP

	bra	TO_GRAM_END

CULCULATION::
	move.l	ON_Y_NUMBER(a6),d0	* x1024
	lsl.l	#8,d0			*
	lsl.l	#2,d0			*
	add.l	ON_X_NUMBER(a6),d0
	add.l	ON_X_NUMBER(a6),d0
	add.l	#$00c0_0000,d0
	move.l	d0,a1

	bsr	TO_GRAM
	bra	TO_GRAM_END

**********************************************************
**			POSTER ON			**
**********************************************************
POSTER_ON::
	move.w	#2,ONE_FRAME_ONLY_FLAG(a6)

	move.l	IMAGE_SIZE(a6),d1

	move.l	d1,-(sp)
	DOS	_MALLOC					*$FF48
	addq.l	#4,sp

		move.l	d0,MEMPTR(a6)
		bmi	MALLOC_ERROR

	move.w	#0,-(sp)			*擪̃ItZbg
	move.l	#192,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d1,-(sp)
	move.l	MEMPTR(a6),-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

			tst.l	d0
			bmi	READ_ERROR

	bra	COMPLETE

**********************************************************
**			View Mode			**
**********************************************************
VIEW_MODE::
						*d7:\\
	move.w	d7,ON_IMAGE_NUMBER(a6)
	move.l	FRAME_NUMBER(a6),d6

	move.l	GET_START_FRAME_NUMBER(a6),d1
	move.l	GET_END_FRAME_NUMBER(a6),d2
	tst.l	d2
	bne	@F

	move.l	d6,GET_END_FRAME_NUMBER(a6)
	move.l	d6,d2
@@:
	cmp.l	d1,d2
	ble	END_FRAME_OVER_START_FRAME	*-s  -e
	cmp.l	d1,d6
	blt	START_FRAME_OVER		*-s  total frame
	cmp.l	d2,d6
	blt	END_FRAME_OVER			*-e  total frame

	sub.l	d1,d2

	cmp.l	d7,d2				*
	ble	ON_FRAME_CHECK			*ʕ\t[

	divu.w	d7,d2
	andi.l	#$0000_FFFF,d2			*d2.w:΂t[

	move.l	IMAGE_SIZE(a6),d1
	move.l	d1,d3
	subq.l	#1,d7				*dbrap
	move.l	d7,d5

@@:
	add.l	d1,d3
	dbra	d7,@B

	move.l	d3,-(sp)			*image
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp
	move.l	d0,MEMPTR(a6)

		bmi	MALLOC_ERROR

	move.l	d0,a0
	move.l	PCM_BLOCK_SIZE(a6),d3
	add.l	d1,d3
	subq.l	#1,d2				*dbrap
	moveq.l	#0,d4

@@:
	add.l	d3,d4
	dbra	d2,@B

	add.l	PCM_BLOCK_SIZE(a6),d4

	moveq.l	#0,d2
	move.l	GET_START_FRAME_NUMBER(a6),d6
	tst.l	d6
	beq	1F

	subq.l	#1,d6
	move.l	IMAGE_SIZE(a6),d0
	add.l	PCM_BLOCK_SIZE(a6),d0

@@:
	add.l	d0,d2
	dbra	d6,@B
1:
	add.l	DATA_OFFSET(a6),d2

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d2,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d1,-(sp)	*TCY
	move.l	a0,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	subq.l	#1,d5

@@:
	move.w	#1,-(sp)			*ݒnSEEK
	move.l	d4,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	adda.l	d1,a0

	move.l	d1,-(sp)	*TCY
	move.l	a0,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	dbra	d5,@B

	bra	COMPLETE

**********************************************************
**			END				**
**********************************************************
TO_GRAM_END::
		move.l	SSP_SAVE(a6),-(sp)	*
		DOS	_SUPER			* [U[[h
		addq.l	#4,sp			*

	bra	END

**********************************************************
**			SUB ROUTINE			**
**********************************************************
TO_GRAM::
	move.l	Y_LENGTH(a6),d6
	subq.l	#1,d6
	move.l	CULC_Y_LENGTH(a6),d4
	move.l	CULC_X_LENGTH(a6),d7
	move.l	d7,d5
	bra	LP1

LP2::
		move.l	d5,d7

LP1::
		move.l	(a0)+,(a1)+
		dbra	d7,LP1

		add.l	d4,a1			* =(512-X)x2
		dbra	d6,LP2
		rts

GET_NUMBER1::
	moveq.l	#0,d0
	moveq.l	#0,d2
	move.l	d7,d5
	subq.l	#1,d5

	subq.l	#2,d7		*dbrap-2
	move.l	d7,d6
1:
	move.l	d6,d7
	move.b	(a0)+,d0
		cmpi.b	#'0',d0			*0`9AA`ZȊO͒e
		bcs	IN_NUMBER_ERR		*
		cmpi.b	#'9'+1,d0		*
		bcc	IN_NUMBER_ERR		*
		subi.b	#$30,d0			*𐔎ɂ

		cmpi.l	#-1,d7
		ble	GET_NUMBER3
2:
	move.l	d0,d1			*d0=d1
	add.l	d1,d1			*d1=x2
	lsl.l	#3,d0			*d0=x8
	add.l	d1,d0			*d0=x10
	dbra	d7,2B

GET_NUMBER3::
	add.l	d0,d2
	moveq.l	#0,d0
	subq.l	#1,d6
	dbra	d5,1B
	rts


SKIPSP0::	addq.l	#1,a2
SKIPSP::
		cmpi.b	#SPACE,(a2)		*
		beq	SKIPSP0
		cmpi.b	#TAB,(a2)		*space&tab͔΂
		beq	SKIPSP0
		rts

TOUPPER::
		cmpi.b	#"a",d0			*Ȃ啶
		bcs	TOUPPER0
		cmpi.b	#"z"+1,d0
		bcc	TOUPPER0
		subi.b	#$20,d0
TOUPPER0::
		rts

**********************************************************
**			Error Routine			**
**********************************************************
USAGE::
	pea.l	USAGE_MSG(pc)
	bra	DISP_ABORT

NOT_XVDDATA::
	pea.l	NOT_XVDDATA_MSG(pc)
	bra	DISP_ABORT

NOT_REV200::
	pea.l	NOT_REV200_MSG(pc)
	bra	DISP_ABORT

NOT_IMAGE_TYPE0::
	pea.l	NOT_IMAGE_TYPE0_MSG(pc)
	bra	DISP_ABORT


IN_NUMBER_ERR::
	pea.l	IN_NUMBER_ERR_MSG(pc)
	bra	DISP_ABORT

NUMBER_OVER::
	pea.l	NUMBER_OVER_MSG(pc)
	bra	DISP_ABORT

OVER_FLOW_FRAME::
	pea.l	OVER_FLOW_FRAME_MSG(pc)
	bra	DISP_ABORT

OVER_X_NUMBER::
	pea.l	OVER_X_NUMBER_MSG(pc)
	bra	DISP_ABORT

OVER_Y_NUMBER::
	pea.l	OVER_Y_NUMBER_MSG(pc)
	bra	DISP_ABORT

END_FRAME_OVER_START_FRAME::
	pea.l	END_FRAME_OVER_START_FRAME_MSG(pc)
	bra	DISP_ABORT

START_FRAME_OVER::
	pea.l	START_FRAME_OVER_MSG(pc)
	bra	DISP_ABORT

END_FRAME_OVER::
	pea.l	END_FRAME_OVER_MSG(pc)
	bra	DISP_ABORT

**********************************************************
**			DOS CALL ERROR			**
**********************************************************
OPEN_ERROR::
	pea.l	OPEN_ERR_MSG(pc)
	bra	DISP_ABORT

MALLOC_ERROR::
	pea.l	MALLOC_ERROR_MSG(pc)
	bra	DISP_ABORT

SEEK_ERROR::
	pea.l	SEEK_ERR_MSG(pc)
	bra	DISP_ABORT

READ_ERROR::
	pea.l	READ_ERR_MSG(pc)
*	bra	DISP_ABORT

DISP_ABORT::
	DOS	_PRINT			*$FF09
	addq.l	#4,sp

END:
	DOS	_EXIT


	.data
	.even

**********************************************************
**			DATA ARIA			**
**********************************************************
USAGE_MSG::
	.dc.b	'.xvd Easy Frame Viewer 2 ver0.6',CR,LF
	.dc.b	'		Programed by ӂȂۂ May 31 1997',CR,LF
	.dc.b	CR,LF
	.dc.b	'usage : xvdfv2 <option> xvdfile',CR,LF
	.dc.b	'option: -f[num] : num = frame number (0n65535)',CR,LF
	.dc.b	'      : -a[x,y] : x,y = load point',CR,LF
	.dc.b	'      : -a      : One Frame Only load',CR,LF
	.dc.b	'      : -v      : View Mode',CR,LF
	.dc.b	'      : -s[num] : num = View Start frame number (0n65535)',CR,LF
	.dc.b	'      : -e[num] : num = View End   frame number (0n65535)',CR,LF,0

OPEN_ERR_MSG::		.dc.b	'DOS _OPEN Error!',CR,LF,0
MALLOC_ERROR_MSG::	.dc.b	'DOS _MALLOC Error!',CR,LF,0
SEEK_ERR_MSG::		.dc.b	'DOS _SEEK Error!',CR,LF,0
READ_ERR_MSG::		.dc.b	'DOS _READ Error!',CR,LF,0

NOT_XVDDATA_MSG::	.dc.b	'This File is not XVDfile.',CR,LF,0
NOT_REV200_MSG::	.dc.b	'This File is not rev2.00.',CR,LF,0
NOT_IMAGE_TYPE0_MSG::	.dc.b	'This File is not Type 0.',CR,LF,0

IN_NUMBER_ERR_MSG::	.dc.b	'Option Number Error!',CR,LF,0
NUMBER_OVER_MSG::	.dc.b	'Frame Number is Over!',CR,LF,0
OVER_FLOW_FRAME_MSG::	.dc.b	'Over Frame: -f[n] : 0n65536',CR,LF,0 
OVER_X_NUMBER_MSG::	.dc.b	'Over X Number: 0x+X_length512',CR,LF,0
OVER_Y_NUMBER_MSG::	.dc.b	'Over Y Number: 0y+Y_Length512',CR,LF,0

END_FRAME_OVER_START_FRAME_MSG::
			.dc.b	'-s[num]  -e[num] Error!',CR,LF,0
START_FRAME_OVER_MSG::	.dc.b	'-s[num]  Total frame Error!',CR,LF,0
END_FRAME_OVER_MSG::	.dc.b	'-e[num]  Total frame Error!',CR,LF,0

	.bss
	.even

WORK::
	.ds.b	WORK_SIZE

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
